<?php
require_once 'modelos/Modelo.php';
require_once 'modelos/DAO.php';

class MUsuarios extends Modelo
{
    public $DAO;

    public function __construct()
    {
        $this->DAO = new DAO();
    }

    public function buscarUsuarios($filtros = array())
    {
        $ftexto = '';
        $factivo = '';
        extract($filtros);

        $SQL = "SELECT * FROM usuarios WHERE 1=1 ";
        if ($factivo != '') {
            $SQL .= " AND activo='$factivo' ";
        }

        $usuarios = $this->DAO->consultar($SQL);

        return $usuarios;
    }

    public function insertarUsuario($DATOS)
    {

        $SQL = "INSERT INTO usuarios (idUsuario, nombre, apellido1, apellido2, sexo, fechaAlta, mail, 
        movil, login, pass, activo) VALUES (NULL, '" . $DATOS["nombre"] . "', '" . $DATOS["apellido1"] . "', '" . $DATOS["apellido2"] . "', 
        '" . $DATOS["sexo"] . "', '" . $DATOS["FAlta"] . "', '" . $DATOS["email"] . "', '" . $DATOS["movil"] . "', '" . $DATOS["login"] . "', '" . password_hash($DATOS["pass"], PASSWORD_BCRYPT) . "', '" . $DATOS["activo"] . "');";


        $usuarios = $this->DAO->insertar($SQL);

        return $usuarios;
    }

    public function actualizarUsuario($DATOS)
    {

        // Primero, asegúrate de que el password_hash se aplique solo una vez
        $password_hashed = password_hash($DATOS["pass"], PASSWORD_BCRYPT);

        $SQL = "UPDATE usuarios SET 
            nombre = '" . $DATOS["nombre"] . "', 
            apellido1 = '" . $DATOS["apellido1"] . "', 
            apellido2 = '" . $DATOS["apellido2"] . "', 
            sexo = '" . $DATOS["sexo"] . "', 
            fechaAlta = '" . $DATOS["FAlta"] . "', 
            mail = '" . $DATOS["email"] . "', 
            movil = '" . $DATOS["movil"] . "', 
            login = '" . $DATOS["login"] . "', 
            pass = '" . $password_hashed . "', 
            activo = '" . $DATOS["activo"] . "'
            WHERE 
            idUsuario = '" . $DATOS["id"] . "';";


        $usuarios = $this->DAO->actualizar($SQL);

        return $usuarios;
    }
} //FIN class MUsuarios
